#!/usr/bin/env python

from Tkinter import *

class App(Frame):
	def __init__(self, master=None):
		Frame.__init__(self, master)
		self.pack(expand=1, fill=BOTH)
		self.bindings = []
		self._create_widgets()
		self.bindkeys()

	def _create_widgets(self):
		menubar = Frame(self, relief='raised', borderwidth=2)
		filemenu = Menubutton(menubar, text='File', underline=0)
		filemenu.pack(side='left')
		filemenu.menu = Menu(filemenu)
		filemenu.menu.add_command(label='Reset', underline=0)
		filemenu.menu.add_command(label='Open', underline=0)
		filemenu.menu.add_command(label='Save', underline=0)
		filemenu.menu.add_command(label='Save as', underline=5)
		filemenu.menu.add_separator()
		filemenu.menu.add_command(label='Exit', command=self.quit,
			underline=1)
		filemenu.config(menu=filemenu.menu)
		menubar.pack(side=TOP, fill=X, expand=0)

		b = Button(self, text='Bind', command=self.bind)
		b.pack(side=TOP)
		b = Button(self, text='Unbind', command=self.unbind)
		b.pack(side=TOP)
		b = Button(self, text='Genevent', command=self.genevent)
		b.pack(side=TOP)
		self.text = Text()
		self.text.insert('end',
			open('/projects/ai4/smartedit/collect.py').read())
		self.text.pack(side=TOP)
		self.text.focus_set()
	
	def deleted(self, event):
		print 'Selection deleted'
	
	def genevent(self):
		self.text.event_generate('<KeyPress-Delete>')
		self.text.event_generate('<KeyPress-BackSpace>')
	
	def bindkeys(self):
		b = self.text.bind('<KeyPress>', self.printevent)
		self.bindings.append('<KeyPress>', b)
#		b = self.text.bind('<KeyRelease>', self.printevent)
#		self.bindings.append('<KeyRelease>', b)
#		b = self.text.bind('<ButtonPress>', self.printevent)
#		self.bindings.append('<ButtonPress>', b)
#		b = self.text.bind('<Motion>', self.printevent)
#		self.bindings.append('<Motion>', b)
#		b = self.text.bind('<ButtonRelease>', self.printevent)
#		self.bindings.append('<ButtonRelease>', b)
#		b = self.text.bind('<Control-Key-P>', self.foo)
#		self.bindings.append('<Control-Key-P>', b)
	
	def unbind(self):
		print 'Bindings:', self.bindings
		for (seq, func) in self.bindings:
			self.text.unbind(seq, func)
	
	def foo(self, event):
		print 'Foo!'
	
	def printevent(self, event):
		print '-' * 79
		print event.keysym
#		for key in dir(event):
#			print '%s: %s' % (key, eval('event.%s' % key))

def main():
	a = App()
	a.mainloop()

if __name__ == '__main__':
	main()

