#!/usr/bin/env python

from Tkinter import *
try:
	import Pmw
except:
	import PmwLocal as Pmw

# Used to log messages in a separate window
class LogWin(Toplevel):
	LOG_MESG_BUFFER = 100
	def __init__(self, label='Messages:', master=None):
		Toplevel.__init__(self)
		self._master = master
		self.protocol('WM_DELETE_WINDOW', self.withdraw)

		l = Label(self, text=label, anchor='w')
		l.pack(side=TOP, expand=0, fill=X)

		self.text = Pmw.ScrolledText(self)
		self.text.pack(side=TOP, expand=1, fill=BOTH)
		self.text.configure(text_state='disabled')

		c = Button(self, text='Close', command=self.withdraw)
		c.pack(side=TOP, expand=0, fill=X)

	def add_message(self, msg):
		self.text.configure(text_state='normal')
		self.text.insert('end', msg + '\n')
		# delete old messages
		while int(float(self.text.index('end'))) >=\
			self.LOG_MESG_BUFFER + 3:
			self.text.delete('1.0', '2.0')
		self.text.see('end')
		self.text.configure(text_state='disabled')

def main():
	l = LogWin()
	l.add_message('Hello world!')
	l.mainloop()

if __name__ == '__main__':
	main()

