#!/usr/bin/env python

# VS domain code for the text editing hypothesis language

from types import *
import string, operator
import vs
from Tkinter import IntVar, TclError

# ---------------------------------------------------------------------------
# Abstract event types

CLIPBOARD = None

# Abstract base class
class Abstract:
	def __init__(self):
		self.type = 'abstract'
	
	def __cmp__(self, newevent):
		return cmp(self.__dict__, newevent.__dict__)	
		
	def __str__(self):
		return '%s()' % self.type
	__repr__ = __str__

class Insert(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'insert'
		# self.text is either a string, or None (bottom)
		self.text = outstate.contents
		self.instate = instate
		self.outstate = outstate

	def __str__(self):
		return '%s(text=%s)' % (self.type, `self.text`)
	__repr__ = __str__

class Select(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'select'
		self.instate = instate
		self.outstate = outstate

	def __str__(self):
		return '%s(%s, %s)' % (self.type, self.instate.pos,
						   self.outstate.pos)
	__repr__ = __str__

class Delete(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'delete'
		self.instate = instate
		self.outstate = outstate
	
	def __str__(self):
		return '%s(%s, %s)' % (self.type, self.instate.pos,
						   self.outstate.pos)
		return '%s(Location)' % self.type
	__repr__ = __str__

class Move(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)

		self.type = 'move'
		self.instate = instate
		self.outstate = outstate
	
	def __str__(self):
		return '%s(%s, %s)' % (self.type, self.instate.pos,
						   self.outstate.pos)
	__repr__ = __str__

class Copy(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'copy'
		self.instate = instate
		self.outstate = outstate
	
class Paste(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'paste'
		self.instate = instate
		self.outstate = outstate
	
class Cut(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'cut'
		self.instate = instate
		self.outstate = outstate

class DeleteSelection(Abstract):
	def __init__(self, instate, outstate):
		Abstract.__init__(self)
		self.type = 'deleteselection'
		self.instate = instate
		self.outstate = outstate
	
# ----------------------------------------------------------------------
# ----------------------------------------------------------------------





