#!/usr/bin/env python

from smarteditlib import collect, db
import yaml
import os

# Converts the SMARTedit scenarios into yaml format so my Java code can do learning on it.
# This is the old version for ICML submission, so it doesn't keep track of the
# clipboard or position information.  It is very coarse-grained.
# The newer version is in collect.py under dump_all_scenarios().

def convertState(state):
  map = {}
  #map['iteration'] = state.iteration_number # All are -1 anyway
  map['pos'] = state.pos
  #se = state.selection_extent # Always empty
  #if len(se) > 0: map['selection'] = se[0]+" "+se[1]
  map['clipboard'] = state.clipboard
  map['contents'] = state.contents
  return map

# Convert pickled object format to YAML format
outPath = "yaml"
os.system("mkdir -p "+outPath)
scenario_names = db.get_scenarios()
scenario_names.sort()
#e = collect.Event("<KeyPress-a>", 1)
#exit
for name in scenario_names:
  scenario = db.load_scenario(name)
  if name == "OKRA": continue # Too big
  if name == "bold-xyz": continue # Some binary encoding messed up
  #e.test_scenario(scenario)
  #continue

  # Build
  map = {}
  map['name'] = scenario.name
  map['description'] = scenario.description
  examples = []
  for ex in scenario.examples:
    exmap = {}
    exmap['before'] = convertState(ex.beforestate)
    exmap['after'] = convertState(ex.afterstate)
    #exmap['events'] = [str(ev.sequence) for ev in ex.events]
    #print exmap['events']
    examples.append(exmap)
  map['examples'] = examples

  # Output
  f = open(outPath+"/"+name+".yaml", "w")
  f.write(yaml.dump(map))
  f.close
  exPath = outPath+"/"+name+".examples"
  os.system("mkdir -p "+exPath)
  for i, ex in zip(xrange(len(examples)), examples):
    f = open("%s/%03d" % (exPath, i), "w")
    f.write(ex['before']['contents'])
    f.close
  f = open("%s/%03d" % (exPath, len(examples)), "w")
  f.write(examples[len(examples)-1]['after']['contents'])
  f.close
  print name+": %d examples" % len(examples)
