package programinduction

import scala.collection.mutable.{ArrayBuffer,HashMap,HashSet}
import fig.exec.Execution
import tea.Utils
import tea.Utils.{map,foreach,fmt,fmts,fmt1,fmt2,returnFirst,assertValid,impossible,fails}
import tea.Utils.{track,begin_track,end_track,logs,dbgs}

object MyUtils {
  def assertSameCounts[A](h1:HashMap[A,Int], h2:HashMap[A,Int]) = {
    h1.keysIterator.foreach { a => require (h1(a) == h2.getOrElse(a, 0), a + " " + h1(a) + " " + h2.get(a)) }
    h2.keysIterator.foreach { a => require (h2(a) == h1.getOrElse(a, 0), a + " " + h2(a) + " " + h1.get(a)) }
  }

  def append[A,B](h:HashMap[A,ArrayBuffer[B]], a:A, b:B) = {
    h.getOrElseUpdate(a, new ArrayBuffer[B]) += b
  }

  def mapList[A](n:Int, f:Int=>A) : List[A] = mapList(0, n, f)
  def mapList[A](a:Int, b:Int, f:Int=>A) : List[A] = {
    def recurse(i:Int) : List[A] = {
      if (i == b) Nil
      else f(i) :: recurse(i+1)
    }
    recurse(a)
  }
  def mapList2[A,B,C](la:List[A], lb:List[B], f:(A,B)=>C) : List[C] = {
    la match { 
      case Nil => require (lb == Nil); Nil
      case a :: as => f(a, lb.head) :: mapList2(as, lb.tail, f)
    }
  }

  def escape(s:String) = "\""+s.replaceAll("\n", "\\\\n").replaceAll("\t", "\\\\t")+"\""
}
