package programinduction

import java.util.{Set,ArrayList,Random}

class WorldOptions {
  import fig.basic.Option

  // Model
  @Option var alpha = 1.0
  @Option var typeStopProb = 0.5
  @Option var roguePrimitiveProb = 0.3
  @Option var multitaskSharing = true
  @Option(gloss="Don't throw an error if encounter combinators containing unregistered primitives") var allowRoguePrimitives = false

  // Sampling
  @Option var random = new Random(1)
  @Option var burnInFrac = 0.0
  @Option var numTrials = 1
  @Option var numIters = 10
  @Option var numHitsPerIter = 1
  @Option var onlyAbstractPrimitiveCombinators = false
  @Option var onlyAbstractBaseTypes = false
  @Option(gloss="When sampling, only consider transformations up to a certain length") var transformMaxLen = 2
  @Option var changeCurrRootProb = 0.2
  @Option var changeCandidateProb = 0.2
  @Option var temperature = 1.0
  @Option var crudeInit = false
  @Option var allowRefactoringFromIter = 0

  // Input
  @Option var scenarioOffset = 0
  @Option var maxScenarios = Integer.MAX_VALUE
  @Option var numTestCases = Integer.MAX_VALUE
  @Option var numTrainTestCases = Integer.MAX_VALUE
  @Option var testCaseRandom = new Random(1)

  // Exhaustive search (for initialization)
  @Option var exhaustiveSearch = false
  @Option var exhaustiveMaxDepth = 3
  @Option var exhaustiveMaxNodes = 10
  @Option var exhaustiveMaxSolutions = 10
  @Option var exhaustiveMaxIters = 100
  @Option var searchSemantics = false
  @Option var keepNodePerBehavior = false

  @Option(gloss="Change the elements of the candidate set (invalidates sampler)") var edenotationChangeSet = false
  @Option(gloss="Even if we're not in the candidate set, still allow jumping back to a candidate (invalidates sampler)") var edenotationAllowJumpBack = false

  // Debugging
  @Option var repCheck = false
  @Option var verbose = 1
  @Option var rememberFullSamples = false
  @Option var outputEvents = false
  @Option var outputStateInterval = 10
  @Option var recordStateInterval = 10
  @Option var rightBranching = false
}
