package textedit;

import java.util.*;
import fig.basic.Option;

public class WorldOptions {
  public int x;
  // Model
  @Option public double alpha = 1.0;
  @Option(gloss="For Pitman-Yor") public double discount = 0.0;
  @Option public double genExtractValueStopProb = 0.5;
  @Option public int numPrimitives = 0;
  @Option public int numRouters = 1+3+3*3;
  @Option public double genPrimitiveProb = 0.5;
  @Option public boolean useLocalPotential = true;
  @Option public boolean multitaskSharing = true;
  @Option public boolean onlyExtractStrings = false;

  // Learning
  @Option public int numTrainExamples = 2;
  @Option public boolean online = false;

  @Option(gloss="Fraction of value nodes to be extracted") public double initFracExtracted = 0.5;

  // Sampling
  @Option public Random random = new Random(1);
  @Option public double burnInFrac = 0.0;
  @Option public int numTrials = 1;
  @Option public int numIters = 10;

  @Option public double initTemperature = 1.0;
  @Option public double finalTemperature = 1.0;
  @Option public boolean sampleCandidates = true;
  @Option public boolean sampleGrouping = true;
  @Option public boolean sampleExtraction = true;

  // Input
  @Option public int scenarioOffset = 0;
  @Option public int maxScenarios = Integer.MAX_VALUE;

  // Debugging
  @Option public boolean repCheck = false;
  @Option public int verbose = 1;
  @Option public boolean rememberFullSamples = false;
  @Option public boolean outputEvents = false;
  @Option public int outputStateInterval = 10;
  @Option public int recordStateInterval = 10;
}
